#!/usr/bin/python
import math, time, random, sys
         
'''
# Dieses Programm berechnet die Determinante einer n x n Matrix durch
# Transformation der Matrix auf Dreiecksgestalt und Produktbildung der
# entstehenden Diagonalelemente. 
'''

def detcalc(at,n):
# Diese Funktion berechnet die Determinante der n x n Matrix a durch
# Transformation auf Dreiecksgestalt.
   a=range(n)
   for i in range(n):
      a[i]=range(n)
      for j in range(n):
         a[i][j]=float(at[i][j])
   if n >=3:
      det = 1.
      fact = 1.
      p = range(n)
      for k in range(0,n):
         if a[p[k]][k]==0:
            #Spalten-Pivot-Suche
            for i in range(k+1,n):
               if a[p[i]][k]!=0.:
                  #Pivot-Element gefunden; vertausche entsprechende Gleichungen
                  tmp = p[i]
                  p[i] = p[k]
                  p[k] = tmp
                  fact = - fact
                  break
               if i == n-1:
                  #kein Pivot-Element vorhanden --> det = 0.
                  det = 0.
                  return det
         for i in range(k+1,n):
            factor = -a[p[i]][k]/a[p[k]][k]
            for j in range(k,n):
               a[p[i]][j]=a[p[i]][j]+factor*a[p[k]][j]
         det = det *a[p[k]][k]
      det = det * fact
      return det
   elif n==2:
      if float(a[0][0])!=0.:
         factor = -a[1][0]/a[0][0]
         a[1][1]=a[1][1]+factor*a[0][1]
         det = a[0][0]*a[1][1]
      else:
         det = -a[1][0]*a[0][1]
      return det
   elif n==1:
      return a[0][0]
   else:
      print "negative entry for matrix dimension; program stops"
      return

#################
# HAUPTPROGRAMM #
#################

print "Dies ist ein Programm, das die Determinante einer gegebenen n x n Matrix berechnet."
print
n = input("Anzahl der Zeilen/Spalten der Matrix eingeben: ")
print 'Anzahl der Zeilen/Spalten der Matrix: ', n
print
# Anlegen der (n x n) - Matrix a
a=range(n)
# Eingabe von a 
print 'gib die Matrix-Koeffizienten zeilenweise und durch Kommata getrennt ein; '
print 'Beispiel: 11.3, 2.7, 3, 4.7'
for i in range(1,n+1):
   zeile= 'Koeffizienten der '+str(i)+'-ten Zeile: '
   if n==1:
      a[0]=range(n)
      a[0][0]=float(input(zeile))
   else:
      a[i-1]=input(zeile)
determa=detcalc(a,n)
print "Die Determinante der eingegebenen Matrix betraegt: ", determa
sys.stdin.readline()
